using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace DeviceCatturaSchermoCS
{
    public partial class Form1 : Form
    {
        //dichiarazione di api
        [DllImport("coredll.dll")]
        private static extern bool BitBlt(
          IntPtr hdcDest,        
          int nXDest,            
          int nYDest,            
          int nWidth,            
          int nHeight,           
          IntPtr hdcSrc,         
          int nXSrc,             
          int nYSrc,             
          System.Int32 dwRop     
          );

        [DllImport("coredll.dll")]
        public extern static System.IntPtr GetDC(System.IntPtr hWnd);

        [DllImport("coredll.dll")]
        public extern static int ReleaseDC(System.IntPtr hWnd, System.IntPtr hDC);  

        public Form1()
        {
            InitializeComponent();
        }

        private void btnCattura_Click(object sender, EventArgs e)
        {
            CatturaForm();
        }
        //cattura e salva l'immagine della sola form
        private void CatturaForm()
        {
            //ottengo handler della form creo un oggetto di tipo bmp per gestire l'immagine
            System.IntPtr srcDC = GetDC(this.Handle);
            System.Drawing.Bitmap bm = new System.Drawing.Bitmap(this.Width, this.Height);
            System.Drawing.Graphics graphics = System.Drawing.Graphics.FromImage(bm);
            System.IntPtr bmDC = graphics.GetHdc();
            //copio la form nella bitmap
            BitBlt(bmDC, 0, 0, bm.Width, bm.Height, srcDC, 0, 0, 0x00CC0020 /*SRCCOPY*/);
            //Rilascio le risorse
            ReleaseDC(this.Handle, srcDC);
            graphics.ReleaseHdc(bmDC);
            graphics.Dispose();
            // Salvo l'immagine in formato jpeg
            string filename = "immagine.jpg";
            bm.Save(filename, System.Drawing.Imaging.ImageFormat.Jpeg);
            MessageBox.Show("Immagine salvata: " + filename);

        }
        //cattura e salva l'immagine di tutta la finestra, compersa la taskbar
        private void CatturaFormConTaskBar()
        {
          //ottengo handler della form creo un oggetto di tipo bmp per gestire l'immagine
            System.IntPtr srcDC = GetDC(IntPtr.Zero);
            System.Drawing.Bitmap bm = new System.Drawing.Bitmap(this.Width, this.Height);
            System.Drawing.Graphics graphics = System.Drawing.Graphics.FromImage(bm);
            System.IntPtr bmDC = graphics.GetHdc();
            //copio la form nella bitmap
            BitBlt(bmDC, 0, 0, bm.Width, bm.Height, srcDC, 0, 0, 0x00CC0020 /*SRCCOPY*/);
            //Rilascio le risorse
            ReleaseDC(IntPtr.Zero, srcDC);
            graphics.ReleaseHdc(bmDC);
            graphics.Dispose();

            // Salvo l'immagine in formato jpeg
            string filename = "immagine.jpg"; 
            bm.Save(filename, System.Drawing.Imaging.ImageFormat.Jpeg);
            MessageBox.Show("Immagine salvata: " + filename);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            CatturaFormConTaskBar();
        }
        

    }
}